"""
Auteur : Patrick WAMPÉ
Livre : Machine Learning et Deep Learning
Des bases à la conception avancée d’algorithmes
Chapitre : 10
"""

def factorielle(n): 
    r=1
    for i in range(1,n+1): 
        r=r*i
    return r 

print(f"Factorielle de {5} : {factorielle(5)}")

def factorielleVersionRecursive(n): 
    if n<=1:
        return 1 
    else:
        return n*factorielleVersionRecursive(n-1) 
        
print(f"Factorielle recursive de {5} : {factorielleVersionRecursive(5)}")

def fibonacci(n): 
    a,b = 0,1
    for i in range(0, n-1):
        c=a+b
        a=b
        b=c
    return b

print(f"Fibonacci de 10 : {fibonacci(10)}")

def fibonacciVersionRecursive(n): 
    if n==0:
        return 0 
    elif n==1:
        return 1
    else:
        return fibonacci(n-1) + fibonacci(n-2)

print(f"Fibonacci recursif de 10 : {fibonacciVersionRecursive(10)}")
